Index: stable/HeuristicLab.Services.WebApp/3.3/WebApp/app.css
===================================================================
--- stable/HeuristicLab.Services.WebApp/3.3/WebApp/app.css	(revision 12685)
+++ stable/HeuristicLab.Services.WebApp/3.3/WebApp/app.css	(revision 12962)
@@ -352,9 +352,4 @@
 }
 
-[ng-click],
-[data-ng-click],
-[x-ng-click] {
-    cursor: pointer;
-}
 
 .navbar-default .navbar-brand {
@@ -419,4 +414,11 @@
 .default-view-container {
   padding: 30px;
+  min-height: 300px;
+}
+
+.default-view-header {
+  padding: 30px;
+  background: #F5F5F5;
+  border-bottom: 1px solid #D3D3D3;
 }
 
@@ -434,2 +436,111 @@
   text-decoration: none;
 }
+
+/*remove button gradient*/
+.btn {
+  background-image: none;
+  filter: none;
+  -webkit-box-shadow: none !important;
+     -moz-box-shadow: none !important;
+       -o-box-shadow: none !important;
+          box-shadow: none !important;
+}
+
+.btn-default {
+  background-image: none;
+  filter: none;
+  -webkit-box-shadow: none !important;
+     -moz-box-shadow: none !important;
+       -o-box-shadow: none !important;
+          box-shadow: none !important;
+}
+
+.btn .btn-default {
+  background-image: none;
+  filter: none;
+  -webkit-box-shadow: none !important;
+     -moz-box-shadow: none !important;
+       -o-box-shadow: none !important;
+          box-shadow: none !important;
+}
+
+.btn-default.active, .btn-default:active{
+  border-color: #adadad;
+}
+
+
+
+.modal-dialog-center {
+    margin: 0;
+    position: absolute;
+    top: 50%;
+    left: 50%;
+}
+
+.modal-header {
+  background: #fafafa;
+}
+
+.modal-body {
+    overflow-y: auto;
+}
+.modal-footer {
+    margin-top: 0;
+}
+
+@media (max-width: 767px) {
+  .modal-dialog-center {
+    width: 100%;
+  }
+}
+
+body.modal-open {
+    overflow: visible;
+}
+
+.table .progress {
+margin-bottom: 0px;
+}
+
+.default-filter-header {
+  padding: 30px;
+  background: #F5F5F5;
+  border-top: 1px solid #D3D3D3;
+  border-bottom: 1px solid #D3D3D3;
+}
+
+.default-tab-filter-header {
+  padding: 30px;
+  background: #F5F5F5;
+  border-bottom: 1px solid #D3D3D3;
+}
+
+.cursor-pointer:hover {
+  cursor: pointer
+}
+
+.app-modal-window .modal-dialog {
+  top: 15%;
+  z-index: 1050;
+}
+
+.pagination>li>a, 
+.pagination>li>span {
+  border-color: #ccc;
+}
+
+.pagination>.active>a, 
+.pagination>.active>a:focus, 
+.pagination>.active>span, 
+.pagination>.active>span:focus {
+  color: black;
+  background: #e0e0e0;
+  border-color: #adadad;
+}
+
+.pagination>.active>a:hover, 
+.pagination>.active>span:hover {
+  color: black;
+  border-color: #ccc;
+  background: #eeeeee;
+}
Index: stable/HeuristicLab.Services.WebApp/3.3/WebApp/app.js
===================================================================
--- stable/HeuristicLab.Services.WebApp/3.3/WebApp/app.js	(revision 12685)
+++ stable/HeuristicLab.Services.WebApp/3.3/WebApp/app.js	(revision 12962)
@@ -2,4 +2,5 @@
 var appName = 'app';
 var appPath = 'WebApp';
+var defaultPageUpdateInterval = 60000;
 
 // route, plugin, menu, section and main app
Index: stable/HeuristicLab.Services.WebApp/3.3/WebApp/helper.js
===================================================================
--- stable/HeuristicLab.Services.WebApp/3.3/WebApp/helper.js	(revision 12685)
+++ stable/HeuristicLab.Services.WebApp/3.3/WebApp/helper.js	(revision 12962)
@@ -7,4 +7,22 @@
 Number.prototype.zeropad = function (n) {
     return (new Array(n + 1).join("0") + this).slice(-n);
+};
+
+Number.prototype.toHHMMSS = function() {
+    d = this;
+    d = Number(d);
+    var years = Math.floor(d / 31536000);
+    var days = Math.floor(d / 86400 % 365);
+    var h = Math.floor(d / 3600 % 24);
+    var m = Math.floor(d % 3600 / 60);
+    var s = Math.floor(d % 3600 % 60);
+    var timeStr = "";
+    if (years > 0) {
+        timeStr = years + "y ";
+    }
+    if (days > 0) {
+        timeStr = timeStr + days + "d ";
+    }
+    return timeStr + h.zeropad(2) + ":" + m.zeropad(2) + ":" + s.zeropad(2);
 };
 
@@ -33,5 +51,4 @@
 };
 
-
 var CSharpDateToString = function (datetime) {
     var date = new Date(Date.parse(datetime));
Index: stable/HeuristicLab.Services.WebApp/3.3/WebApp/libs/angularjs/fittext/ng-FitText.js
===================================================================
--- stable/HeuristicLab.Services.WebApp/3.3/WebApp/libs/angularjs/fittext/ng-FitText.js	(revision 12962)
+++ stable/HeuristicLab.Services.WebApp/3.3/WebApp/libs/angularjs/fittext/ng-FitText.js	(revision 12962)
@@ -0,0 +1,76 @@
+﻿/* ng-FitText.js v3.3.3
+ * https://github.com/patrickmarabeas/ng-FitText.js
+ *
+ * Original jQuery project: https://github.com/davatron5000/FitText.js
+ *
+ * Copyright 2015, Patrick Marabeas http://marabeas.io
+ * Released under the MIT license
+ * http://opensource.org/licenses/mit-license.php
+ *
+ * Date: 06/05/2015
+ */
+
+(function (window, document, angular, undefined) {
+
+    'use strict';
+
+    angular.module('ngFitText', [])
+      .value('config', {
+          'debounce': false,
+          'delay': 250,
+          'loadDelay': 10,
+          'min': undefined,
+          'max': undefined
+      })
+
+      .directive('fittext', ['$timeout', 'config', 'fitTextConfig', function ($timeout, config, fitTextConfig) {
+          return {
+              restrict: 'A',
+              scope: true,
+              link: function (scope, element, attrs) {
+                  angular.extend(config, fitTextConfig.config);
+
+                  element[0].style.display = 'inline-block';
+                  element[0].style.lineHeight = '1';
+
+                  var parent = element.parent();
+                  var compressor = attrs.fittext || 1;
+                  var loadDelay = attrs.fittextLoadDelay || config.loadDelay;
+                  var nl = element[0].querySelectorAll('[fittext-nl],[data-fittext-nl]').length || 1;
+                  var minFontSize = attrs.fittextMin || config.min || Number.NEGATIVE_INFINITY;
+                  var maxFontSize = attrs.fittextMax || config.max || Number.POSITIVE_INFINITY;
+
+                  var resizer = function () {
+                      element[0].style.fontSize = '10px';
+                      var ratio = element[0].offsetHeight / element[0].offsetWidth / nl;
+                      element[0].style.fontSize = Math.max(
+                        Math.min((parent[0].offsetWidth - 6) * ratio * compressor,
+                          parseFloat(maxFontSize)
+                        ),
+                        parseFloat(minFontSize)
+                      ) + 'px';
+                  };
+
+                  $timeout(function () { resizer() }, loadDelay);
+
+                  scope.$watch(attrs.ngModel, function () { resizer() });
+
+                  config.debounce
+                    ? angular.element(window).bind('resize', config.debounce(function () { scope.$apply(resizer) }, config.delay))
+                    : angular.element(window).bind('resize', function () { scope.$apply(resizer) });
+              }
+          }
+      }])
+
+      .provider('fitTextConfig', function () {
+          var self = this;
+          this.config = {};
+          this.$get = function () {
+              var extend = {};
+              extend.config = self.config;
+              return extend;
+          };
+          return this;
+      });
+
+})(window, document, angular);
Index: stable/HeuristicLab.Services.WebApp/3.3/WebApp/plugins/about/about.cshtml
===================================================================
--- stable/HeuristicLab.Services.WebApp/3.3/WebApp/plugins/about/about.cshtml	(revision 12685)
+++ stable/HeuristicLab.Services.WebApp/3.3/WebApp/plugins/about/about.cshtml	(revision 12962)
@@ -28,5 +28,5 @@
                 <div class="panel-body">
                     <p><strong>Support</strong>: <a href="App/RedirectUrl?url=http://groups.google.com/group/heuristiclab">HeuristicLab Google Group</a></p>
-                    <p><strong>Inquiries</strong>: ​<a ng-click="mailToSupport()">support(at)heuristiclab.com</a></p>
+                    <p><strong>Inquiries</strong>: ​<a class="cursor-pointer" ng-click="mailToSupport()">support(at)heuristiclab.com</a></p>
                     <p><strong>Heuristic and Evolutionary Algorithms Laboratory (HEAL)</strong>: <a href="App/RedirectUrl?url=http://heal.heuristiclab.com">​http://heal.heuristiclab.com</a></p>
                     <p><strong>HeuristicLab development site</strong>: <a href="App/RedirectUrl?url=http://dev.heuristiclab.com">http://dev.heuristiclab.com</a></p>
@@ -36,5 +36,5 @@
                         <span class="glyphicon glyphicon-phone-alt"></span> +43 50804 22030<br />
                         <span class="glyphicon glyphicon-print"></span> +43 50804 21599<br />
-                        <span class="glyphicon glyphicon-envelope"></span> <a ng-click="mailToStefanWagner()">stefan.wagner(at)heuristiclab.com</a><br />
+                        <span class="glyphicon glyphicon-envelope"></span> <a class="cursor-pointer" ng-click="mailToStefanWagner()">stefan.wagner(at)heuristiclab.com</a><br />
                     </p>
                 </div>
Index: stable/HeuristicLab.Services.WebApp/3.3/WebApp/plugins/login/login.cshtml
===================================================================
--- stable/HeuristicLab.Services.WebApp/3.3/WebApp/plugins/login/login.cshtml	(revision 12685)
+++ stable/HeuristicLab.Services.WebApp/3.3/WebApp/plugins/login/login.cshtml	(revision 12962)
@@ -14,5 +14,5 @@
                             <div class="input-group">
                                 <span class="input-group-addon"><i class="glyphicon glyphicon-user"></i></span>
-                                <input type="text" class="form-control" name="Username" placeholder="User"
+                                <input type="text" class="form-control" name="Username" placeholder="Username"
                                        ng-model="user.Username">
                             </div>
Index: stable/HeuristicLab.Services.WebApp/3.3/WebApp/plugins/plugins/plugins.cshtml
===================================================================
--- stable/HeuristicLab.Services.WebApp/3.3/WebApp/plugins/plugins/plugins.cshtml	(revision 12685)
+++ stable/HeuristicLab.Services.WebApp/3.3/WebApp/plugins/plugins/plugins.cshtml	(revision 12962)
@@ -21,7 +21,7 @@
                                 <th>#</th>
                                 <th ts-criteria="Name">Name</th>
-                                <th ts-criteria ="AssemblyName">Assembly</th>
+                                <th ts-criteria="AssemblyName">Assembly</th>
                                 <th ts-criteria="LastReload">Last reload</th>
-                                <th>Status</th>
+                                <th class="text-center">Status</th>
                                 <th></th>
                             </tr>
@@ -33,5 +33,5 @@
                                 <td>{{plugin.AssemblyName}}</td>
                                 <td>{{plugin.LastReload}}</td>
-                                <td>
+                                <td class="text-center">
                                     <span ng-hide="plugin.Exception" class="glyphicon glyphicon glyphicon-ok" style="color: green"></span>
                                     <span ng-show="plugin.Exception" class="glyphicon glyphicon glyphicon-remove" style="color: darkred"
@@ -39,5 +39,5 @@
                                 </td>
                                 <td>
-                                    <a ng-href="" data-ng-click="reloadPlugin(plugin.Name)">Reload</a>
+                                    <a ng-href="" class="cursor-pointer" data-ng-click="reloadPlugin(plugin.Name)">Reload</a>
                                 </td>
                             </tr>
Index: stable/HeuristicLab.Services.WebApp/3.3/WebApp/shared/filter/filters.js
===================================================================
--- stable/HeuristicLab.Services.WebApp/3.3/WebApp/shared/filter/filters.js	(revision 12685)
+++ stable/HeuristicLab.Services.WebApp/3.3/WebApp/shared/filter/filters.js	(revision 12962)
@@ -1,3 +1,3 @@
-﻿(function () {
+﻿(function() {
     var module = appMainPlugin.getAngularModule();
     module.filter('kbToGB', function () {
Index: stable/HeuristicLab.Services.WebApp/3.3/WebApp/shared/layout/layout.cshtml
===================================================================
--- stable/HeuristicLab.Services.WebApp/3.3/WebApp/shared/layout/layout.cshtml	(revision 12685)
+++ stable/HeuristicLab.Services.WebApp/3.3/WebApp/shared/layout/layout.cshtml	(revision 12962)
@@ -24,9 +24,10 @@
     <meta charset="utf-8" />
     <meta name="viewport" content="width=device-width, initial-scale=1">
+    <meta http-equiv="pragma" content="no-cache" />
     <title>HeuristicLab Hive</title>
     <link href="~/WebApp/HeuristicLab.ico" rel="shortcut icon" type="image/x-icon" />
     @Styles.Render("~/Bundles/Vendors/css")
     @Styles.Render("~/Bundles/WebApp/css")
-    <link rel="stylesheet" type="text/css" href="http://fonts.googleapis.com/css?family=Open+Sans:300,400,600,700">
+    <link rel="stylesheet" type="text/css" href="//fonts.googleapis.com/css?family=Open+Sans:300,400,600,700">
     <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
     <!--[if lt IE 9]>
@@ -63,15 +64,12 @@
                 <div class="navbar-content">
                     <ul class="nav navbar-nav navbar-right">
-                        @if (Request.IsAuthenticated)
-                        {
+                        @if (Request.IsAuthenticated) {
                             <li>
                                 <span class="navbar-text">Hello @User.Identity.Name!</span>
                             </li>
                             <li>
-                                <a ng-href="" data-ng-click="logout()">Logout</a>
+                                <a ng-href="#" data-ng-click="logout()">Logout</a>
                             </li>
-                        }
-                        else
-                        {
+                        } else {
                             <li>
                                 <a ng-href="#/login" data-ng-click="hideMenu()">Login</a>
@@ -97,7 +95,7 @@
 </div>
 <script type="text/javascript">
-$('.navbar-collapse').on('click', 'li a', function () {
-    $('.navbar-collapse').collapse('hide');
-});
+    $('.navbar-collapse').on('click', 'li a', function () {
+        $('.navbar-collapse').collapse('hide');
+    });
 </script>
 </body>